<?php

use JouwWeb\DocData\DocData;
use JouwWeb\DocData\Type;


class DocDataClass 
{
    private $apiClient;

    protected function setUp($testmode = true)
    {
        $this->apiClient = new DocData(MERCHANT_NAME, MERCHANT_PASSWORD, $testmode);
    }


    public function Create($reg_data, $shopid, $testmode = true)
    {
        $name = new Type\Name();
        $name->setFirst($reg_data["First Name"]);
        $name->setLast($reg_data["Last Name"]);

        $shopper = new Type\Shopper();
        $shopper->setId(1);
        $shopper->setGender('U');
        $shopper->setName($name);
        $shopper->setEmail($reg_data["Email Address"]);
        $shopper->setLanguage(new Type\Language('en'));

        $totalGrossAmount = new Type\Amount(intval($reg_data["inv_total"]*100));
        $totalGrossAmount->setCurrency($reg_data["currency"]);
               
        $address = new Type\Address();
        $address->setStreet($reg_data["Address Line 1"]);
        //$address->setHouseNumber(1);
        $address->setPostalCode($reg_data["Post Code"]);
        $address->setCity($reg_data["City"]);
        $address->setCountry(new Type\Country($reg_data["Country"]));

        $billTo = new Type\Destination();
        $billTo->setName($name);
        $billTo->setAddress($address);

        $paymentPreferences = new Type\PaymentPreferences();
        $paymentPreferences->setProfile($shopid);
        $paymentPreferences->setNumberOfDaysToPay(4);
		
		$this->setUp($testmode);
		
	      $response = $this->apiClient->create(
            $shopid."_".$reg_data["reg_id"].microtime(),//or microtime()
            $shopper,
            $totalGrossAmount,
            $billTo,
            $paymentPreferences
        );

		return $key = $response->getKey();
    }


    public function StatusPaid($key)
    {
        
        //Please read the manual about the paidLevel
		$this->setUp();
        $paidLevel = $this->apiClient->statusPaid($key);

		return $paidLevel;

    }
}
