<?php

header('Access-Control-Allow-Origin: *');
header('Access-Control-Allow-Headers: Origin,Content-Type,Authorization,X-Auth-Token');
header('Access-Control-Allow-Methods: GET,POST,PUT,PATCH,DELETE,HEAD,OPTIONS');

 ini_set('display_errors', 1);
 ini_set('display_startup_errors', 1);
 error_reporting(E_ALL);

$config = include('config.php');

$db = new DataBase;
$db->connect($config["dbhost"], $config["dbname"], $config["dbuser"], $config["dbpass"]);

$invoices = $config["invoices"];

class Database
{
	private $connection;
	private $query;

	public function connect($host, $db, $user, $pass)
	{
        try {
            $charset='UTF8';
			$this->connection = new PDO("pgsql:dbname=$db;host=$host", $user, $pass);

		} catch (PDOException $e) {
			print "Error!: " . $e->getMessage();
		}
	}

	public function query($query, $params)
	{
		$this->query = $this->connection->prepare($query);
        return $this->query->execute($params);


	}

	public function insert($query, $params)
	{


		$this->query = $this->connection->prepare($query);
		if($this->query->execute($params)) {
			//print "lastinsertid";
			return $this->connection->lastInsertId();
		}

	}

	public function getCount()
	{
		return $this->query->rowCount();
	}

	public function getContent()
	{
		return $this->query->fetchAll(PDO::FETCH_ASSOC);
	}

}

function new_invoice($reg_data) {
	global $db, $map_arr;

	$timestamp = date('Y-m-d H:i:s', time());
	$amount = $reg_data["inv_total"];

	$db->query("SELECT
				id
			FROM
				events.invoices
			WHERE registration_id = ?
			;", array($reg_data["reg_id"]));

	if($db->getCount() == 0) {

		if ($inv_id = $db->insert("INSERT INTO events.invoices (registration_id,payment_type, reg_type, amount, timestamp)	VALUES (?,?,?,?,?);",
		    array($reg_data["reg_id"], $reg_data["payment_type"], $reg_data["reg_id"], $amount, $timestamp))) {
		//        echo nl2br (".............. new invoice - insert worked - return stuff");
						    return array("inv_id" => $inv_id, "amount" => $amount, "timestamp" => $timestamp);
		}
		else {
			return false;
		}
	}
	else {
		return false;
	}
}


function new_proforma($reg_data) {
    global $db, $map_arr;

    $timestamp = date('Y-m-d H:i:s', time());
    $amount = $reg_data["inv_total"];

    $db->query("SELECT
				id
			FROM
				events.proforma
			WHERE registration_id = ?
			;", array($reg_data["reg_id"]));

    if($db->getCount() == 0) {

        if ($inv_id = $db->insert("INSERT INTO events.proforma (registration_id,payment_type, reg_type, amount, timestamp)	VALUES (?,?,?,?,?);",
            array($reg_data["reg_id"], $reg_data["payment_type"], $reg_data["reg_id"], $amount, $timestamp))) {
                //        echo nl2br (".............. new invoice - insert worked - return stuff");
                return array("inv_id" => $inv_id, "amount" => $amount, "timestamp" => $timestamp);
            }
            else {
                return false;
            }
    }
    else {
        return false;
    }
}


function retrieve_invoice($reg_data) {
    global $db;

    $db->query("SELECT
				id, amount, timestamp
			FROM
				events.invoices
			WHERE registration_id = ?
			;", array($reg_data["reg_id"]));

    if($db->getCount() == 0) {

         return false;

    }
    else {

        $dbdata = $db->getContent();

        $inv_id = $dbdata[0]['id'];
        $amount = $dbdata[0]['amount'];
        $timestamp = $dbdata[0]['timestamp'];

        return array("inv_id" => $inv_id, "amount" => $amount, "timestamp" => $timestamp);
    }
}


function retrieve_proforma($reg_data) {
    global $db;

    $db->query("SELECT
				id, amount, timestamp
			FROM
				events.proforma
			WHERE registration_id = ?
			;", array($reg_data["reg_id"]));

    if($db->getCount() == 0) {

        return false;

    }
    else {

        $dbdata = $db->getContent();

        $inv_id = $dbdata[0]['id'];
        $amount = $dbdata[0]['amount'];
        $timestamp = $dbdata[0]['timestamp'];

        return array("inv_id" => $inv_id, "amount" => $amount, "timestamp" => $timestamp);
    }
}


function new_payment($reg_data, $payment_key, $status = 5, $provider = "_docdata") {
	global $db, $map_arr, $config;

	$timestamp = date('Y-m-d H:i:s', time());

		if ($pay_id = $db->insert("INSERT INTO events.payment_transactions (registration_id, status, amount, currency, provider, timestamp, data, payment_key)
									VALUES (?, ?, ?, ?, ?,?,?,?);",
		    array($reg_data["reg_id"], $status, $reg_data["inv_total"], $reg_data["currency"], $provider, $timestamp, json_encode(array("changed_by_name" => $reg_data["user_name"], "changed_by_id" => $reg_data["user_id"])), $payment_key))) {
								    $idup = $db->query("UPDATE event_registration.registrations SET transaction_id = ? WHERE id = ?",
								array($pay_id, $reg_data["reg_id"]));

			return array("pay_id" => $pay_id, "timestamp" => $timestamp);
		}
		else {
	    return false;
		}

}


function update_reg($reg_data, $tr_status) {
	global $db;

	if ($tr_status == 2) {
		$idup = $db->query("UPDATE event_registration.registrations SET state = 1 WHERE id = ?", array($reg_data["reg_id"]));
		$idup = $db->query("UPDATE events.payment_transactions SET status = 1 WHERE registration_id = ?", array($reg_data["reg_id"]));

		return true;
	}
	else {
		return false;
	}
}


function get_payment_key($trans_id) {
	global $db;


	$db->query("SELECT * FROM events.payment_transactions WHERE id = ? AND provider = ?;", array($trans_id, "_docdata"));
	if($db->getCount() != 0) {
		$dbdata = $db->getContent();
		return $dbdata[0]["payment_key"];
	}
	else {
		return false;
	}

}

function get_reg_data($uuid, $payment_type = "Bank Transfer") {

	global $db, $products, $config;

	if (!isset($uuid)) {
		return false;
	}

	$db->query("SELECT
				reg.id as reg_id, reg.friendly_id as friendly_id, reg.user_id as user_id, reg.event_id as event_id,
                reg.transaction_id as trans_id, reg.registration_form_id as form_id, reg.submitted_dt, reg.state,
                reg_data.data,

                pay_trans.provider,
                pay_trans.timestamp as payment_timestamp,

                field_data.field_id,
                item_data.title,
                form_data.title as form_title,
                user_data.first_name as user_first_name, user_data.last_name as user_last_name
			FROM
				event_registration.registrations reg
			LEFT JOIN event_registration.registration_data reg_data ON ( reg.id = reg_data.registration_id)

            LEFT JOIN events.payment_transactions pay_trans ON ( reg.transaction_id = pay_trans.id)

            LEFT JOIN event_registration.forms form_data ON ( reg.registration_form_id = form_data.id)
			LEFT JOIN event_registration.form_field_data field_data ON (reg_data.field_data_id = field_data.id)
            LEFT JOIN event_registration.form_items item_data ON (item_data.current_data_id = field_data.id)
            LEFT JOIN users.users user_data ON ( reg.user_id = user_data.id)
			WHERE reg.uuid = ?
			ORDER BY reg.id
			;", array($uuid));

	if($db->getCount() != 0) {
		$dbdata = $db->getContent();

		$event_id = $dbdata[0]['event_id'];
		$pay_provider = $dbdata[0]['provider'];
		$payment_timestamp = $dbdata[0]['payment_timestamp'];
		$form_id = $dbdata[0]['form_id'];
		$form_title = $dbdata[0]['form_title'];
		$reg_id = $dbdata[0]['reg_id'];
		$trans_id = $dbdata[0]['trans_id'];
		$friendly_id = $dbdata[0]['friendly_id'];
		$payment_state = $dbdata[0]['state'];

		$User_id = $dbdata[0]['user_id'];
		$User_name = $dbdata[0]['user_first_name'] . " " . $dbdata[0]['user_last_name'];



		if ($User_id == "") {
		    $User_id = "0";
		};

		if ($User_name == "") {
		    $User_name = "Non logged in user";
		};

		foreach ($dbdata as $arr) {
			$reg_data[$arr["title"]] = json_decode($arr["data"]);
		}

		$db->query("SELECT
				evt.country_vat_number as vat_number, evt.country_vat_name as vat_name, evt.country_vat_rate as vat_rate,
                 evt.start_dt as event_start, evt.end_dt as event_end, evt.invoice_payment, evt.timezone
			FROM
				events.events evt
				WHERE evt.id = ?
			;", array($event_id));

		$country_name = "Country Name";
		$country_number = "XX########";
		$country_vat = "0.00";
		$event_start = "01/01/2010";
		$event_end = "31/12/2010";

		if($db->getCount() != 0) {
		    $dbdata = $db->getContent();
		    $invoice_payment = $dbdata[0]['invoice_payment'];
		    $country_name = $dbdata[0]['vat_name'];
		    $country_vat = $dbdata[0]['vat_rate'];
		    $country_number = $dbdata[0]['vat_number'];
		    $event_start_raw = date_create($dbdata[0]['event_start']);
		    $event_end_raw = date_create($dbdata[0]['event_end']);
		    $event_timezone = $dbdata[0]['timezone'];


		    //$event_start = date_format($event_start_raw, 'l jS F Y \, g:ia ');
		    // $event_end = date_format($event_end_raw, 'l jS F Y \, g:ia ');

		    $event_start = date_format($event_start_raw, 'j M Y\, G:i ');
		    $event_end= date_format($event_end_raw, 'j M Y\, G:i ');

		}

		$db->query("SELECT
				reg.base_price as price, reg.currency as currency, reg.event_id event_id, events.title as events_title,
				reg.country_vat_number as vat_number, reg.country_vat_name as vat_name, reg.country_vat_rate as vat_rate

			FROM
				event_registration.registrations reg
			LEFT JOIN events.events events ON ( event_id = events.id)
			WHERE reg.uuid = ?
			;", array($uuid));

		$currency = "GBP";
		$price = 0;
		$title = "NO Event Found";

		if($db->getCount() != 0) {
		   $dbdata = $db->getContent();
		   $price = $dbdata[0]['price'];
		   $currency = $dbdata[0]['currency'];
		   $title = $dbdata[0]['events_title'] . " " . $form_title;
		   $eventitle = $dbdata[0]['events_title'];

		   // Set participant specific VAT data (used with reverse charge VAT)
           if ($dbdata[0]['vat_name'] !== null) {
               $country_name = $dbdata[0]['vat_name'];
           }

           if ($dbdata[0]['vat_rate'] !== null) {
               $country_vat = $dbdata[0]['vat_rate'];
           }

           if ($dbdata[0]['vat_number'] !== null) {
               $country_number = $dbdata[0]['vat_number'];
           }
		}

		$reg_data["user_id"] = $User_id;
		$reg_data["user_name"] = $User_name;

		$reg_data["reg_id"] = $reg_id;
		$reg_data["event_id"] = $event_id;
		$reg_data["form_id"] = $form_id;
		$reg_data["invoice_payment"] = $invoice_payment;
		$reg_data["trans_id"] = $trans_id;
		$reg_data["friendly_id"] = $friendly_id;
		$reg_data["payment_state"] = $payment_state;

		$reg_data["vat_rate"] = $country_vat;
		$reg_data["country_name"] = $country_name;
		$reg_data["country_number"] = $country_number;
		$reg_data["event_title"] = $eventitle;


		$reg_data["pay_provider"] = $pay_provider;
		$reg_data["payment_timestamp"] = $payment_timestamp;

		$reg_data["event_start"] = $event_start;
		$reg_data["event_end"] = $event_end;
		$reg_data["timezone"] = $event_timezone;

		$reg_data["net_total"] = $price;
		$reg_data["vat_total"] = $reg_data["vat_rate"] * $reg_data["net_total"] / 100;
		$reg_data["inv_total"] = $reg_data["net_total"] + $reg_data["vat_total"];


		$reg_data["items"] = $title;
		$reg_data["price"] = $price;
		$reg_data["currency"] = $currency;

        // Determine if this is a Proforma or Invoice, based on past issued documents

		$db->query("SELECT
				payment_type
			FROM
				events.invoices
			WHERE registration_id = ?
			;", array($reg_data["reg_id"]));

		if($db->getCount() != 0) {

		    $dbdata = $db->getContent();

		    $payment_type = $dbdata[0]['payment_type'];
		}

		$db->query("SELECT
				payment_type
			FROM
				events.proforma
			WHERE registration_id = ?
			;", array($reg_data["reg_id"]));

		if($db->getCount() != 0) {

		    $dbdata = $db->getContent();

		    $payment_type = $dbdata[0]['payment_type'];
		}

		$reg_data["payment_type"] = $payment_type;

		// now sort out potential invoice / proforma

		if ($reg_data['payment_type'] == "Bank Transfer") {

		//    echo nl2br (".............. bank transfer in reg data");

		    switch ($reg_data["invoice_payment"]) {
		        case "":
		        case "registration":
		            $reg_data["invoice_suffix"] = "TW";
		            break;
		        case "payment":
		            $reg_data["invoice_suffix"] = "PF";
		            break;
		        case "event":
		            $reg_data["invoice_suffix"] = "TW";
		            break;
		    }

		} else {

		//    echo nl2br (".............. CC in in reg data");

		    $reg_data["invoice_suffix"] = "TW";
		}

		return $reg_data;

	}

	return false;

}

function format_price($value,$currency) {
	if ($value == 0) {
		return "";
	}
	else {
	    if ($currency == "GBP") {
 	        return "£".number_format($value, 2, ",", " ");
 		}
		if  ($currency =="USD") {
	        return "$".number_format($value, 2, ",", " ");
	    }
	    if  ($currency == "EUR") {
	        return "€".number_format($value, 2, ",", " ");
	    }

	    return "$".number_format($value, 2, ",", " ");

	}

}


function gen_invoice($reg_data, $inv_type) {

    global $products, $invoices, $config;

    // here we need to decide on which invoice template to use, along with which date to put on the invoice
    // we have a couple of helpful flags.
    // on reg-data if pay-provider - null, then no payment has been taken,
    // on reg-data if pay-provider = manual, then the invoice has been paid via bank transfer
    // on reg-data the invoice_payment flag can be null (which means we default to registration), registration, payment, or event
    // using the above we should be able to work out invoice date and type

    $proformainv = false;
    $generate_remit_message = false;

    $dt = new DateTime($reg_data["date"]);
    $invdata["inv_date"] = $dt->format("j F Y");

    switch ($reg_data["invoice_payment"]) {
        case "":
        case "registration":
           // echo nl2br (".............. registration .......................");
            // in both cases can use normal template
            if ($inv_type == "credit_card") {
           //     echo nl2br (".............. CC .......................");
                $invfile = "../invoice-gen/invoices-templates/".$invoices["credit_card"];

            }
            else {
//                echo nl2br (".............. BT .......................");
                $invfile = "../invoice-gen/invoices-templates/".$invoices["bank_transfer_pending"];
                $generate_remit_message = true;
            }
            break;
        case "payment":
       //     echo nl2br (".............. payment .......................");
             //need to sort out different templates for bank transfer - proforma and normal
            if ($inv_type == "credit_card") {
        //        echo nl2br (".............. CC .......................");
                $invfile = "../invoice-gen/invoices-templates/".$invoices["credit_card"];

            }
            else {
     //           echo nl2br (".............. BT .......................");
                if ($reg_data["payment_state"] == "5") {
       //             echo nl2br (".............. BT norm.......................");
                   $invfile = "../invoice-gen/invoices-templates/".$invoices["bank_transfer_proforma"];

                } else {
        //            echo nl2br (".............. BT prof.......................");
                   $invfile = "../invoice-gen/invoices-templates/".$invoices["bank_transfer"];
                   $dt = new DateTime($reg_data["payment_timestamp"]);
                   $invdata["inv_date"] = $dt->format("j F Y");

                   $proformainv = true;

                  }
            }
            break;
        case "event":
       //     echo nl2br (".............. event .......................");
            //need to sort out different templates for bank transfer - proforma and normal
            if ($inv_type == "credit_card") {
       //         echo nl2br (".............. CC .......................");
                $invfile = "../invoice-gen/invoices-templates/".$invoices["credit_card"];

                $dt = new DateTime($reg_data["event_start"]);
                $invdata["inv_date"] = $dt->format("j F Y");


            }
            else {
       //         echo nl2br (".............. BT .......................");
                if ($reg_data["pay_provider"] == "_manual") {
       //             echo nl2br (".............. BT new date.........");
                    $invfile = "../invoice-gen/invoices-templates/".$invoices["bank_transfer"];

                    $dt = new DateTime($reg_data["event_start"]);
                    $invdata["inv_date"] = $dt->format("j F Y");


                } else {
        //            echo nl2br (".............. BT old date .......................");
                    $invfile = "../invoice-gen/invoices-templates/".$invoices["bank_transfer"];

                }
            }
            break;
    }
    //echo nl2br (".............. invoice .......................");
    //echo nl2br ($inv_type);
    //echo nl2br (".............. invoice .......................");
    //print_r($reg_data);
    //exit();

    // create new PDF document
    $pdf = new TCPDF(PDF_PAGE_ORIENTATION, PDF_UNIT, PDF_PAGE_FORMAT, true, 'UTF-8', false);

    // set document information
    $pdf->SetCreator($config["pdf"]["creator"]);
    $pdf->SetAuthor($config["pdf"]["author"]);
    $pdf->SetTitle($config["pdf"]["title"]);
    $pdf->SetSubject($config["pdf"]["subject"]);
    $pdf->SetKeywords($config["pdf"]["keywords"]);

    $pdf->setPrintHeader(false);
    $pdf->setPrintFooter(false);

    foreach ($config["pdf"]["fonts"] as $key => $value) {
        $fontname = TCPDF_FONTS::addTTFfont($value["filename"], $value["type"], '', $value["flags"]);
    }

    $pdf->setImageScale(1.8); //scale

    // ---------------------------------------------------------
    $pdf->SetAutoPageBreak(false, 0);

    $pdf->AddPage();


    $invdata["rec_addr"][0] = "{$reg_data["First Name"]} {$reg_data["Last Name"]}";
    $invdata["rec_addr"][1] = "{$reg_data["Organization"]}";
    $invdata["rec_addr"][2] = "{$reg_data["Address Line 1"]}";
    $invdata["rec_addr"][3] = "{$reg_data["City"]} {$reg_data["Post Code"]}";
    $invdata["rec_addr"][4] = "{$reg_data["Country"]}";
    $invdata["rec_addr"][5] = "{$reg_data["Email Address"]}";

    $invdata["rec_vat"] = $reg_data["Your VAT Number"];

    //$dt = new DateTime($reg_data["date"]);
    //$invdata["inv_date"] = $dt->format("j F Y");

    $invdata["rec_ref"] = $reg_data["Your Reference"];


    $invdata["issuer_vat"] =  $reg_data["country_number"];
    $invdata["inv_nr"] = $reg_data["inv_nr"];




    $items[0] = $reg_data["items"];
    $price[0] = $reg_data["net_total"];


    $inv_currency = $reg_data["currency"];
    //$vat_rate = $config["vat_rate"];
    $vat_rate = $reg_data["vat_rate"];
    $country_name = $reg_data["country_name"];
    $net_total = array_sum($price);
    $vat_total = $vat_rate * $net_total / 100;
    $inv_total = $net_total + $vat_total;


    $svgfile = file_get_contents ($invfile);


    $xml = simplexml_load_string($svgfile);

    //  template start
    $result = $xml->xpath("/*[name()='svg']/*[@id='invoice-data']/*[@id='invoice-date']"  );
    $result[0]->tspan = $invdata["inv_date"];


    $result = $xml->xpath("/*[name()='svg']/*[@id='invoice-data']/*[@id='recipient-address']"  );
    $result[0]->tspan[0] = $invdata["rec_addr"][0];
    $result[0]->tspan[1] = $invdata["rec_addr"][1];
    $result[0]->tspan[2] = $invdata["rec_addr"][2];
    $result[0]->tspan[3] = $invdata["rec_addr"][3];
    $result[0]->tspan[4] = $invdata["rec_addr"][4];
    $result[0]->tspan[5] = $invdata["rec_addr"][5];

    $result = $xml->xpath("/*[name()='svg']/*[@id='invoice-data']/*[@id='recipient-vat']"  );
    $result[0]->tspan = $invdata["rec_vat"];

    $result = $xml->xpath("/*[name()='svg']/*[@id='invoice-data']/*[@id='issuer-vat']"  );
    $result[0]->tspan = $invdata["issuer_vat"];

    $result = $xml->xpath("/*[name()='svg']/*[@id='invoice-data']/*[@id='invoice-date']"  );
    $result[0]->tspan = $invdata["inv_date"];

    $result = $xml->xpath("/*[name()='svg']/*[@id='invoice-data']/*[@id='invoice-no']"  );
    $result[0]->tspan = $invdata["inv_nr"];

    $result = $xml->xpath("/*[name()='svg']/*[@id='invoice-data']/*[@id='customer-ref']"  );
    $result[0]->tspan = $invdata["rec_ref"];

    // start of currency display

    $result = $xml->xpath("/*[name()='svg']/*[@id='invoice-data']/*[@id='text4224-0-6']"  );
    $result[0]->tspan = $inv_currency;



    $result = $xml->xpath("/*[name()='svg']/*[@id='invoice-data']/*[@id='text4224-33-5-0']"  );
    $result[0]->tspan = "Invoice Total: ".$inv_currency;

    $result = $xml->xpath("/*[name()='svg']/*[@id='invoice-data']/*[@id='text4224-33-5-6']"  );
    $result[0]->tspan = "VAT @ ". $country_name. " ". $vat_rate . "%";

    if ($proformainv || $generate_remit_message)
    {
        $result = $xml->xpath("/*[name()='svg']/*[@id='invoice-data']/*[@id='text4224-33-57-3']"  );
        $result[0]->tspan = "Please remit in " . $inv_currency . " immediately by direct transfer to:";
    }



    // end if currency display
    $result = $xml->xpath("/*[name()='svg']/*[@id='invoice-data']/*[@id='item-descr']"  );
    $result[0]->tspan[0] = $items[0];
    $result[0]->tspan[1] = "";
    $result[0]->tspan[2] = "";
    $result[0]->tspan[3] = "";
    $result[0]->tspan[4] = "";
    $result[0]->tspan[5] = "";
    $result[0]->tspan[6] = "";
    $result[0]->tspan[7] = "";
    $result[0]->tspan[8] = "";
    $result[0]->tspan[9] = "";

    $result = $xml->xpath("/*[name()='svg']/*[@id='invoice-data']/*[@id='item-price']"  );
    $result[0]->tspan[0] = format_price($price[0],$inv_currency);
    $result[0]->tspan[1] = "";
    $result[0]->tspan[2] = "";
    $result[0]->tspan[3] = "";
    $result[0]->tspan[4] = "";
    $result[0]->tspan[5] = "";
    $result[0]->tspan[6] = "";
    $result[0]->tspan[7] = "";
    $result[0]->tspan[8] = "";
    $result[0]->tspan[9] = "";


    $result = $xml->xpath("/*[name()='svg']/*[@id='invoice-data']/*[@id='net-total']"  );
    $result[0]->tspan = format_price($net_total,$inv_currency);

    $result = $xml->xpath("/*[name()='svg']/*[@id='invoice-data']/*[@id='vat-total']"  );
    $result[0]->tspan = format_price($vat_total,$inv_currency);

    $result = $xml->xpath("/*[name()='svg']/*[@id='invoice-data']/*[@id='invoice-total']"  );
    $result[0]->tspan = format_price($inv_total,$inv_currency);

    // old template end

    $svgfile_r = $xml->asXml();

    $pdf->ImageSVG($file='@'.$svgfile_r, $x=0, $y=0, $w='', $h='', $link='', $align='', $palign='', $border=0, $fitonpage=false);


    $outfname = dirname(__FILE__).'/invoice-gen/invoices/invoice_'.$reg_data["inv_nr"].'.pdf';
    $pdf->Output($outfname, 'F');


    return $outfname;
}

?>
